using System;
using System.Runtime.InteropServices;

/// <summary>
/// AWG-10K2 API library definitions
/// </summary>
public class AWG10K2
{
	//
	// Return code
	//
    public const int AWG10K2_OK = 0;
    public const int AWG10K2_INVALID_ID = 1;
    public const int AWG10K2_DEVICE_NOT_FOUND = 2;
    public const int AWG10K2_DEVICE_NOT_OPENED = 3;
    public const int AWG10K2_INVALID_PARAMETER = 4;
    public const int AWG10K2_MEMORY_ERROR = 5;
    public const int AWG10K2_COMMUNICATION_ERROR = 6;
    public const int AWG10K2_EXECUTION_ERROR = 7;
    public const int AWG10K2_OTHER_ERROR = 8;

    //
	// Control Mode
    //
	public const byte AWG10K2_CONTROL_MODE_REMOTE  = 0;		// [g(PC)
	public const byte AWG10K2_CONTROL_MODE_TRIGGER  = 1;	// OgK[
	
    //
	// Output Mode
    //
	public const byte AWG10K2_OUTPUT_MODE_CONTINUE  = 0;	// A
	public const byte AWG10K2_OUTPUT_MODE_REPEAT  = 1;		// JԂ
	
    //
	// Trigger Type
    //
	public const byte AWG10K2_TRIGGER_TYPE_RISING  = 0;		// GbW
	public const byte AWG10K2_TRIGGER_TYPE_FALLING  = 1;	// GbW
	
    //
	// Status
    //
	public const byte AWG10K2_STATUS_NO_DATA = 0;	// g`o͒~(g`f[^ݒ)
    public const byte AWG10K2_STATUS_READY = 1;	    // g`o͒~(g`f[^ݒ)
    public const byte AWG10K2_STATUS_RUNNING = 2;	// g`o͒

    //
	// Functions definitions
	//
    [DllImport("AWG10K2.dll")]
    public static extern int AWG10K2_GetNumberOfDevices (out int Number);
    [DllImport("AWG10K2.dll")]
    public static extern int AWG10K2_GetSerialNumber (int Index, out int SerialNumber);
    [DllImport("AWG10K2.dll")]
    public static extern int AWG10K2_Open (out byte ID);
    [DllImport("AWG10K2.dll")]
    public static extern int AWG10K2_OpenBySerialNumber (int SerialNumber, out byte ID);
    [DllImport("AWG10K2.dll")]
    public static extern int AWG10K2_Close(byte ID);

    [DllImport("AWG10K2.dll", CharSet = CharSet.Ansi)]
    public static extern int AWG10K2_SetFile (byte ID, string FilePath);
    [DllImport("AWG10K2.dll")]
    public static extern int AWG10K2_SetParametersAndWaveData (byte ID, byte ControlMode, byte OutputMode, int RepeatCount, byte TriggerType, int SamplingRate, int SamplingCount, [MarshalAs(UnmanagedType.AsAny), InAttribute(), OutAttribute()] object WaveData); 
    [DllImport("AWG10K2.dll")]
    public static extern int AWG10K2_Start (byte ID);
    [DllImport("AWG10K2.dll")]
    public static extern int AWG10K2_Stop (byte ID);
    [DllImport("AWG10K2.dll")]
    public static extern int AWG10K2_GetStatus (byte ID, out byte Status);
    [DllImport("AWG10K2.dll")]
    public static extern int AWG10K2_OutputPort (byte ID, byte Port);
    [DllImport("AWG10K2.dll")]
    public static extern int AWG10K2_InputPort (byte ID, out byte Port);
}